/*******************************************
紅音製作所 www5.big.or.jp/~high/VENIO/
COPYRIGHT(C)VENIO WORKS ALL RIGHTS RESERVED.
*******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <math.h>
#include "SDL.h"
#include "SDL_opengl.h"

SDL_Surface *mWIN; //メインウィンドウ
Uint32 cntA,cntB,now,lev,wit;//FPS用

const int WIW=480;	//ウィンドウ-幅
const int WIH=320;	//ウィンドウ-高さ
#define REC 64			//図形の大きさ
//------------------------------------------------------------------------------初期化
void inits()
{
if(SDL_Init(SDL_INIT_VIDEO)==-1)	SDL_Quit();//初期化失敗で終了
//メインウィンドウ作成
SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1);
mWIN=SDL_SetVideoMode(WIW,WIH,32,SDL_OPENGL	//|SDL_FULLSCREEN
);
SDL_WM_SetCaption("OpenGL Test Window", NULL);//windowの名前

glClearColor( 0.0, 0.0, 0.0, 1.0 );//バックの色
glShadeModel(GL_FLAT);//シェーディングモード
glMatrixMode(GL_PROJECTION);
glOrtho(0.0, WIW, WIH, 0.0, 0.0, 1.0);
glMatrixMode(GL_MODELVIEW);
}
//------------------------------------------------------------------------------終了イベント
int endKeys()
{
SDL_Event Qevents;
if(SDL_PollEvent(&Qevents))
switch(Qevents.type)
	{
	case SDL_QUIT:		//ウィンドウのボタン
		return 0;	
	case SDL_KEYDOWN:	//escキー
		if(Qevents.key.keysym.sym==SDLK_ESCAPE)	return 0;
	}
return 1;
}
//------------------------------------------------------------------------------バック地と中心線
void back()
{
glClear(GL_COLOR_BUFFER_BIT);//バック地を黒で塗り潰し
glLoadIdentity();
//ウィンドウの中心線の描画
glBegin(GL_LINES);
glColor3d(0.0,	0.0,	1.0);
	glVertex2i(0,WIH/2);	glVertex2i(WIW,WIH/2);
	glVertex2i(WIW/2,0);	glVertex2i(WIW/2,WIH);
glEnd();
}
//------------------------------------------------------------------------------物体A
void modelA()
{
glColor3d(1.0, 0.0, 0.0);//色
glBegin(GL_LINE_LOOP);
	glVertex2i(-REC*0.5,-REC*0.5);
	glVertex2i( REC*0.5,-REC*0.5);
	glVertex2i( REC*0.5, REC*0.5);
	glVertex2i(-REC*0.5, REC*0.5);
glEnd();
}
//------------------------------------------------------------------------------物体Aの描画
void modelA_fix()
{
glLoadIdentity();
glTranslated(REC*0.5, REC*0.5, 0.0);//ずれた分だけ修正
modelA();
}
//------------------------------------------------------------------------------物体Aの移動
void modelA_move()
{
glLoadIdentity();
static double poX,poY;//移動用

if( (poX+=2.0)>WIW)poX=-REC;//座標計算
if( (poY+=1.0)>WIH)poY=-REC;

glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);
modelA();
}
//------------------------------------------------------------------------------物体Aの拡大縮小
void modelA_scal()
{
glLoadIdentity();
//拡大縮小
static double scl,vec;//拡大縮小用
if     ( (vec==0)&&(scl+=0.1)>=1 ) {scl=1;vec=1;}
else if( (vec==1)&&(scl-=0.1)<=0 ) {scl=0;vec=0;}

glPushMatrix();
	glTranslated(REC*0.5, REC*0.5, 0.0);//ずれた分だけ修正
	glScaled(1.0*scl,1.0*scl,0.0);//拡大縮小
	modelA();
glPopMatrix();

//おまけ　拡大縮小しながら移動
static double poX,poY;//移動用
if( (poX+=1.0)>WIW)poX=-REC;//座標計算
if( (poY+=0.5)>WIH)poY=-REC;
glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);//ずれた分だけ修正
glScaled(scl,scl,0.0);//拡大縮小
modelA();
}
//------------------------------------------------------------------------------物体Aの回転
void modelA_rots()
{
glLoadIdentity();

static double rot;
if( (rot+=1.0)>=360 )rot=0;//回転
glTranslated(REC*0.5, REC*0.5, 0.0);//ずれた分だけ修正
glRotated(rot, 0.0, 0.0, 1.0);//回転
modelA();

//おまけ　回転しながら移動
glLoadIdentity();
static double poX,poY;
if( (poX+=0.50)>WIW)poX=-REC;//座標計算
if( (poY+=0.25)>WIH)poY=-REC;
glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);//ずれた分だけ修正
glRotated(360-rot, 0.0, 0.0, 1.0);//回転
modelA();
}
//------------------------------------------------------------------------------描画
void modelDrow()
{
modelA_fix();//物体A描画
modelA_move();//移動
modelA_scal();//拡大縮小
modelA_rots();//回転
}
//------------------------------------------------------------------------------main
int main(int argc,char *argv[])
{
inits();//初期化
while(endKeys()!=0)//メインループ
	{
	back();
	modelDrow();
	
	//フレームレート調整
	now=SDL_GetTicks();
	wit=now-lev;
	if(wit<16)SDL_Delay((16-wit));
	lev=SDL_GetTicks();

	if(now-cntB>=5000)//FPS確認用
		{
		printf("%d\n",cntA/5);
		cntA=1;	cntB=now;
		}	else cntA+=1;
	
	SDL_GL_SwapBuffers();//画面更新
	}
SDL_Quit();
return 0;
}